<template>
  <button 
    :class="classType"
    @click="action"
  >
    {{ text }}
  </button>
</template>

<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
  props: {
    text: {
      type: String,
      required: true,
    },
    action: {
      type: Function,
      required: true,
    },
    buttonType: {
      type: String,
      default: 'primary',
    },
  },

  computed: {
    classType(): { [key: string]: boolean } {
      const classes: { [key: string]: boolean } = {
        button: true,
      };

      classes[`btn--${this.buttonType}`] = true;

      return classes;
    },
  },
});
</script>

<style lang="postcss">
.button {
  @apply m-4 py-4 px-8 rounded border-4 bg-transparent;
}

.button:hover {
  transition: all 0.25s ease-out;
}

/*-----------------------------------------------
---              Primary Styles               ---
------------------------------------------------*/

.btn--primary {
  @apply text-primary .border-primary;
}

.btn--primaryAlt {
  @apply bg-primary text-white .border-primary;
}

.btn--primary:hover {
  @apply bg-primary text-white border-primary;
}

.btn--primaryAlt:hover {
  @apply bg-primary-dark text-white border-primary-dark;
}

/*-----------------------------------------------
---              Success Styles               ---
-------------------------------------------------*/

.btn--success {
  @apply text-green border-green; 
}

.btn--successAlt {
  @apply bg-green text-white .border-green;
}

.btn--success:hover {
  @apply bg-green text-white border-green;
}

.btn--successAlt:hover {
  @apply bg-green-dark text-white border-green-dark; 
}

/*-----------------------------------------------
---              Warning Styles               ---
-------------------------------------------------*/

.btn--warning {
  @apply text-yellow-dark border-yellow-dark; 
}

.btn--warningAlt {
  @apply bg-yellow-dark text-white .border-yellow-dark;
}

.btn--warning:hover {
  @apply bg-yellow-dark text-white border-yellow-dark;
}

.btn--warningAlt:hover {
  @apply bg-yellow-darker text-white border-yellow-darker; 
}

/*----------------------------------------------
---              Danger Styles               ---
------------------------------------------------*/

.btn--danger {
  @apply text-red border-red; 
}

.btn--dangerAlt {
  @apply bg-red text-white .border-red;
}

.btn--danger:hover {
  @apply bg-red text-white border-red;
}

.btn--dangerAlt:hover {
  @apply bg-red-dark text-white border-red-dark; 
}

/*------------------------------------------------
---              Disabled Styles               ---
--------------------------------------------------*/

.btn--disabled {
  @apply text-grey-dark border-grey-dark;
}

.btn--disabledAlt {
  @apply bg-grey-dark border-grey-dark text-white;
}
</style>
